#include "hmg.ch"

FUNCTION Main()
  LOCAL cZipFile := "MyZipFile.zip"
  LOCAL cMyFile  := "File222.txt"
  LOCAL cMyFiles := "*.txt"
  
  FOR i=1 TO 1000
  	STRFILE('File'+ALLTRIM(STR(i))+'.txt', 'File'+ALLTRIM(STR(i))+'.txt')
  NEXT i
  Msginfo("1000 Files are created")
  
  DEFINE WINDOW Test AT 157 , 162 WIDTH 550 HEIGHT 350 VIRTUAL WIDTH Nil VIRTUAL HEIGHT Nil TITLE "Hello World!!!!!" ICON NIL MAIN NOMAXIMIZE NOMINIMIZE CURSOR NIL ON INIT Nil ON RELEASE Nil ON INTERACTIVECLOSE Nil ON MOUSECLICK Nil ON MOUSEDRAG Nil ON MOUSEMOVE Nil ON SIZE Nil ON MAXIMIZE Nil ON MINIMIZE Nil ON PAINT Nil BACKCOLOR Nil NOTIFYICON NIL NOTIFYTOOLTIP NIL ON NOTIFYCLICK Nil ON GOTFOCUS Nil ON LOSTFOCUS Nil ON SCROLLUP Nil ON SCROLLDOWN Nil ON SCROLLLEFT Nil ON SCROLLRIGHT Nil ON HSCROLLBOX Nil ON VSCROLLBOX Nil

    DEFINE MAIN MENU
        DEFINE POPUP "File"
            MENUITEM "Zip" ACTION (ZipFiles( cZipFile, cMyFiles, 'M'), Msgbox('All files *.txt are zipped'))  
            MENUITEM "UnZip" ACTION (UnZipFiles( cZipFile , cMyFile, ".\Unzip") , Msgbox('File222.txt is extracted to Unzip folder')) 
            SEPARATOR
            MENUITEM "Exit" ACTION ThisWIndow.Release 
        END POPUP
    END MENU

END WINDOW
Center Window Test
Activate Window Test
  
RETURN NIL

***********************************************************************************
Function ZipFiles(cArch, cFiles, cMode)
Local aFiles:={},cPath, cFileName, cExt, aDir, aFile

//cArch - name of archive file
//cFiles - Files name to zip, you can use wildchars * or ?. Or you can create list of files as an array
//cMode - A - add file to archive,  M - move file to archive

IF VALTYPE(cFiles)='A'
	//list of files is allready as array
	aFiles:=cFiles
ELSE
	WAIT WINDOW "Making list of files to archive ..." NOWAIT                
	HB_FNameSplit( cFiles, @cPath, @cFileName, @cExt )
	aDir := DIRECTORY( cPath+ cFileName + cExt )
	*aDir := HB_DirScan( cPath, cFileName + cExt )
	FOR EACH aFile IN aDir
		AADD(aFiles,cPath + aFile[ 1 ])
	NEXT
	WAIT CLEAR
ENDIF

IF LEN(aFiles)>0
	DEFINE WINDOW oZipFile AT 347 , 538 WIDTH 285 HEIGHT 130 TITLE "Zipping";
		ICON Nil NOSIZE NOSYSMENU;
		ON INIT StartZip(cArch, aFiles, cMode);
		ON RELEASE Nil;
		BACKCOLOR Nil
	
		ON KEY ALT+F4 ACTION Nil
	
		LABEL(10,10,250,20,"Zip in progress ...",'C')
		
		LABEL(30,10,250,29,"","C")
        
		DEFINE PROGRESSBAR ProgBar
        	ROW    60
        	COL    10
        	WIDTH  220
        	HEIGHT 20
        	RANGEMIN 1
        	RANGEMAX 10
        	VALUE 0
        	TOOLTIP "Progress bar"
        	HELPID Nil
        	VISIBLE .T.
        	SMOOTH .T.
        	VERTICAL .F.
        	BACKCOLOR Nil
        	FORECOLOR Nil
        	END PROGRESSBAR

        	LABEL(62,235,40,20,"0 %","L")
        END WINDOW

        Center window oZipFile
        Activate window oZipFile
        
ENDIF

Return Nil
***************************************************************
Function StartZip(cArch, aFiles, cMode)
Local success, nPosU:=0, aFile

IF VALTYPE(cMode)#'C'
	cMode:='A'
ENDIF

oZipFile.ProgBar.Value:=0
oZipFile.ProgBar.RANGEMIN:=1
oZipFile.ProgBar.RANGEMAX:=LEN(aFiles)

success:=hb_ZipFile( cArch /* Name of the zip file */ ,;
                    aFiles /* An array containing files to compress, Drive and/or path can be used */ ,;
                    9 /* Compression level ranging from 0 to 9 */ ,;
                    {|cFile , nPos| (RefrProgZip(cFile,nPos,ALLTRIM(STR(INT((nPos/LEN(aFiles))*100)))+" %"))} /* Code block to execute while compressing */ ,;
                    .F. /* <lOverWrite> Toggle to overwite the file if exists */ ,;
                    Nil /* <cPassword> Password to encrypt the files */ ,;
                    Nil /* <lWithPath> Toggle to store the path or not */ ,;
                    Nil /* <lWithDrive> Toggle to store the Drive letter and path or not */ )

IF !success
	MsgStop("Error durning Zipping!","Error")
ELSE
	IF UPPER(cMode)='M'
		//Moving files = delete files after zipping
		oZipFile.E_10_10.Value:="Erasing zipped files ..."
		RefrProgZip("",nPosU,"0 %")

		FOR EACH aFile IN aFiles
			nPosU++
			RefrProgZip(aFile,nPosU,ALLTRIM(STR(INT((nPosU/LEN(aFiles))*100)))+" %")
			FILEDELETE(aFile)
		NEXT
	ENDIF
ENDIF

ThisWindow.Release
RETURN Nil
***********************************************************************************
Function RefrProgZip(cRFile, nRPos, cRPrct)
SetProperty(ThisWindow.name,'E_30_10','Value',cRFile)
SetProperty(ThisWindow.name,'ProgBar','Value',nRPos)
SetProperty(ThisWindow.name,'E_62_235','Value',cRPrct)
DO EVENTS
Return Nil
***********************************************************************************
Function UnZipFiles(cArch, cFiles, cPathToUnzip)
//cArch - name of archive file
//cFiles - name of file to extract, if empty extract all files
//cPathToUnzip - path to extract fies, if empty extract in current folder 

IF FILE(cArch)
	DEFINE WINDOW oUnZipFile AT 347 , 538 WIDTH 285 HEIGHT 130 TITLE "UnZipping";
		ICON Nil NOSIZE NOSYSMENU;
		ON INIT StartUnZip(cArch, cFiles, cPathToUnzip);
		ON RELEASE Nil;
		BACKCOLOR Nil
	
		ON KEY ALT+F4 ACTION Nil
	
		LABEL(10,10,250,20,"UnZip in progress ...",'C')
		
		LABEL(30,10,250,29,"","C")
        
		DEFINE PROGRESSBAR ProgBar
        	ROW    60
        	COL    10
        	WIDTH  220
        	HEIGHT 20
        	RANGEMIN 1
        	RANGEMAX 10
        	VALUE 0
        	TOOLTIP "Progress bar"
        	HELPID Nil
        	VISIBLE .T.
        	SMOOTH .T.
        	VERTICAL .F.
        	BACKCOLOR Nil
        	FORECOLOR Nil
        	END PROGRESSBAR

        	LABEL(62,235,40,20,"0 %","L")
        END WINDOW

        Center window oUnZipFile
        Activate window oUnZipFile
       
ENDIF

Return Nil
***************************************************************
Function StartUnZip(cArch, aFiles ,cPathToUnzip)
Local success

IF VALTYPE(cPathToUnzip)#'C' .OR. EMPTY(cPathToUnzip)
	cPathToUnzip:='.\'
ENDIF

IF VALTYPE(aFiles)#'C' .OR. EMPTY(aFiles)
	aFiles := hb_GetFilesInZip( cArch ) 
ENDIF

oUnZipFile.ProgBar.Value:=0
oUnZipFile.ProgBar.RANGEMIN:=1
oUnZipFile.ProgBar.RANGEMAX:=LEN(aFiles)

success:=hb_UnZipFile( cArch /* Name of the zip file */ ,;
                      {|cFile, nPos| (RefrProgZip(cFile,nPos,ALLTRIM(STR(INT((nPos/LEN(aFiles))*100)))+" %"))} /* Code block to execute while decompressing */ ,;
                      .T. /* Toggle to create directory if needed */ ,;
                      Nil /* Password to use to extract files */ ,;
                      cPathToUnzip /* Path to extract the files */ ,;
                      aFiles /* An file or an Array of files to extract */ )

IF !success
	MsgStop("Error durning UnZipping!","Error")
ENDIF

ThisWindow.Release
RETURN Nil

**********************************************************************************************
FUNCTION Label(nRow, nCol, nSzer, nWys, cTresc, cAtrybut, aKolor, aTlo, cFont, nSize, cNazEtyk)

DEFAULT cNazEtyk:="E_"+ALLTRIM(STR(nRow))+"_"+ALLTRIM(STR(nCol))
cAtrubut:=UPPER(cAtrybut)

DEFINE LABEL &cNazEtyk
        ROW    nRow
        COL    nCol
        WIDTH  nSzer
        HEIGHT nWys
        VALUE cTresc
        IF ValType(cAtrybut)='C'
        	DO CASE
        		CASE 'R'$cAtrybut
        			RIGHTALIGN .T.
        		CASE 'C'$cAtrybut
        			CENTERALIGN .T. 
        	ENDCASE
        
        	IF 'B'$cAtrybut
        		FONTBOLD .T.
        	ENDIF
	
        	IF 'I'$cAtrybut
           	FONTITALIC .T.
          ENDIF

          IF 'U'$cAtrybut
        		FONTUNDERLINE .T.
        	ENDIF
        ENDIF
        
        IF ValType(aKolor)='A' 
        	FONTCOLOR aKolor
        ELSE
        	FONTCOLOR Nil
        ENDIF
        
        IF ValType(aTlo)='A'        
        	BACKCOLOR atlo
        ELSE
        	BACKCOLOR Nil
        ENDIF
        
        IF ValType(cFont)='C'        
        	FONTNAME cFont
        ENDIF
        
        IF ValType(nSize)='N'
        	FONTSIZE nSize
        ENDIF
        
        VISIBLE .T.
    END LABEL
RETURN Nil

